function varargout = Sound_GUI(varargin)
% SOUND_GUI MATLAB code for Sound_GUI.fig
%      SOUND_GUI, by itself, creates a new SOUND_GUI or raises the existing
%      singleton*.
%
%      H = SOUND_GUI returns the handle to a new SOUND_GUI or the handle to
%      the existing singleton*.
%
%      SOUND_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SOUND_GUI.M with the given input arguments.
%
%      SOUND_GUI('Property','Value',...) creates a new SOUND_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Sound_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Sound_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Sound_GUI

% Last Modified by GUIDE v2.5 19-Apr-2018 20:47:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Sound_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @Sound_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
end

% --- Executes just before Sound_GUI is made visible.
function Sound_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Sound_GUI (see VARARGIN)
% Choose default command line output for Sound_GUI
handles.output = hObject;

% Listen for changes in the slider position
addlistener(handles.ampSlider, 'Value', 'PostSet', @ContSliderDragAmp);
addlistener(handles.freqSlider, 'Value', 'PostSet', @ContSliderDragFreq);
addlistener(handles.durationSlider, 'Value', 'PostSet', @ContSliderDragDuration);

% Update handles structure
guidata(hObject, handles);
handles.ampBox.String = '10';
handles.freqBox.String = '440';
handles.durationBox.String = '1';

% Display the initial graph
updateGraph(10, 440, 1, handles);

% UIWAIT makes Sound_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);
end
% --- Outputs from this function are returned to the command line.
function varargout = Sound_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

end
% --- Executes on button press in btnPlay.
function btnPlay_Callback(hObject, eventdata, handles)
% hObject    handle to btnPlay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[f, d] = updateGraph(handles.ampSlider.Value, handles.freqSlider.Value, handles.durationSlider.Value, handles);

sound(f, 1/d);

end

% Updates the graph accordingly when called
function [f_ret, delta]=updateGraph(amp, freq, dur, handles)
    delta = 0.00005;
    t = 0:delta:dur;
    t_mask = (t < .03);
    f = amp * sin(2 * pi * freq * t(t_mask));
    f_ret = amp * sin(2 * pi * freq * t);
    plot(handles.soundPlot, t(t_mask), f);
    ylim(handles.soundPlot,[-25 25]);
end

function ContSliderDragAmp(hObject, eventdata)
    handles = guidata(eventdata.AffectedObject);
    val = handles.ampSlider.Value;
    r = round(val, 1);
    handles.ampSlider.Value = r;
    handles.ampBox.String = r;
    updateGraph(r, handles.freqSlider.Value, handles.durationSlider.Value, handles);
end

function ContSliderDragFreq(hObject, eventdata)
    handles = guidata(eventdata.AffectedObject);
    val = handles.freqSlider.Value;
    r = round(val);
    handles.freqSlider.Value = r;
    handles.freqBox.String = r;
    updateGraph(handles.ampSlider.Value, r, handles.durationSlider.Value, handles);

end

function ContSliderDragDuration(hObject, eventdata)
    handles = guidata(eventdata.AffectedObject);
    val = handles.durationSlider.Value;
    r = round(val);
    handles.durationSlider.Value = r;
    handles.durationBox.String = r;
end

% --- Executes on slider movement.
function ampSlider_Callback(hObject, eventdata, handles)
% hObject    handle to ampSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.ampBox.String = hObject.Value;
% --- Executes during object creation, after setting all properties.
end

function ampSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ampSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
end

% --- Executes on slider movement.
function freqSlider_Callback(hObject, eventdata, handles)
% hObject    handle to freqSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.freqBox.String = hObject.Value;
end
% --- Executes during object creation, after setting all properties.
function freqSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freqSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

end

function ampBox_Callback(hObject, eventdata, handles)
% hObject    handle to ampBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ampBox as text
%        str2double(get(hObject,'String')) returns contents of ampBox as a double

end

% --- Executes during object creation, after setting all properties.
function ampBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ampBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end

function freqBox_Callback(hObject, eventdata, handles)
% hObject    handle to freqBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of freqBox as text
%        str2double(get(hObject,'String')) returns contents of freqBox as a double

end
% --- Executes during object creation, after setting all properties.
function freqBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to freqBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end

% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over btnPlay.
function btnPlay_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to btnPlay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

end


% --- Executes on slider movement.
function durationSlider_Callback(hObject, eventdata, handles)
% hObject    handle to durationSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

end
% --- Executes during object creation, after setting all properties.
function durationSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to durationSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

end

function durationBox_Callback(hObject, eventdata, handles)
% hObject    handle to durationBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of durationBox as text
%        str2double(get(hObject,'String')) returns contents of durationBox as a double

end 

% --- Executes during object creation, after setting all properties.
function durationBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to durationBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end
